#include <commdlg.h>
#include <stdlib.h>
#include <math.h>
#include <mem.h>
#include <string.h>
#include <stdio.h>

#define STRICT

#define MIN(a,b) ((a<b)?a:b)
#define MAX(a,b) ((a>b)?a:b)
#include "..\defs.h"
#include "..\color.h"
#include "..\picture.h"
#include "..\statbar.h"
#include "..\fft2d.h"

HPALETTE hpal=NULL,hlpal;
PALETTEENTRY pe[256];
HINSTANCE hInst;
HMENU hMenu;
HBRUSH hbackbrush,himagebackbrush;
int screen_bitspixel,total_childs=0,last_zoom=1,nuntitled=1,
    filter=0,lmouse=0,rmouse=0,_x0,_y0,_x1,_y1,_x00,_y00;
char str[256],buf[256];
unsigned char pal_map[256];
LOGPALETTE lgpl;
HWND hWndMDIClient,hWndFrame,hWndFocusChild=0,hWndStatBar=0;
HACCEL hAccel=0;
HCURSOR hourglass;

int get_exp(char *exp,double *result);

extern double _X_,_Y_,_SX_,_SY_,_UX_,_UY_;

class windowextra
		{
		 public:
		 class picture8 *pic8;
		 int x,y,zoom;
		 class fftdata2D *fftdata;

		 ~windowextra() { if (this)
									{
									 if (pic8) delete pic8;
									 if (fftdata) delete fftdata;
									 fftdata=0;
									 pic8=0;
									}
							 };
		  windowextra() { pic8=NULL; fftdata=0; };
		 } ;

void DrawFan(HDC hdc)
{
	 int dx,dy;
	 float a1,a2,n1,n2;
	 POINT p[6];
	 class windowextra *we;
	 we=(class windowextra *)GetWindowLong(hWndFocusChild,0);

    n1=we->fftdata->nn1/2;
    n2=we->fftdata->nn2/2;
    p[0].x=p[3].x=n1-1;
    p[0].y=p[3].y=n2-1;

    dx=_x0-n1;
    dy=_y0-n2;
    a1=findangle(dx,dy);
    dx=_x1-n1;
    dy=_y1-n2;
    a2=findangle(dx,dy);

    p[1].x=1000*cos(a1);
    p[1].y=1000*sin(a1);
    p[2].x=1000*cos(a2);
    p[2].y=1000*sin(a2);
	 p[4].x=-p[1].x;
    p[4].y=-p[1].y;
    p[5].x=-p[2].x;
    p[5].y=-p[2].y;
    p[1].x+=p[0].x;
    p[1].y+=p[0].y;
    p[2].x+=p[0].x;
	 p[2].y+=p[0].y;
    p[4].x+=p[0].x;
    p[4].y+=p[0].y;
    p[5].x+=p[0].x;
    p[5].y+=p[0].y;
    if (_x0<n1&&_x1>=n1 ||
        _x0>=n1&&_x1<n1)
        {
         dx=p[2].x;
         p[2].x=p[5].x;
         p[5].x=dx;
         dx=p[2].y;
         p[2].y=p[5].y;
         p[5].y=dx;
        }

    Polygon(hdc,p,3);
	 Polygon(hdc,&p[3],3);
}

int GetOpenFileName_(char *file,char *filter,char *defext,char *title)
{
  OPENFILENAME ofn;
  char szFile[256]="",szFileTitle[256]="";

  ofn.lStructSize = sizeof( OPENFILENAME );
  ofn.hwndOwner = hWndFrame;
  ofn.hInstance = hInst;
  ofn.lpstrFilter = filter;
  ofn.lpstrCustomFilter = NULL;
  ofn.nMaxCustFilter = 0;
  ofn.nFilterIndex = 1;
  ofn.lpstrFile = (LPSTR)szFile;
  ofn.nMaxFile = sizeof( szFile );
  ofn.lpstrFileTitle = szFileTitle;
  ofn.nMaxFileTitle = sizeof( szFileTitle );
  ofn.lpstrInitialDir = NULL;
  ofn.lpstrTitle = title;
  ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
  ofn.nFileOffset = 0;
  ofn.nFileExtension = 0;
  ofn.lpstrDefExt = defext;
  ofn.lCustData = NULL;
  ofn.lpfnHook = NULL;
  ofn.lpTemplateName = NULL;
  if (GetOpenFileName( &ofn ))
	   {
      strcpy(file,ofn.lpstrFile);
      if (!strcmp(file+ofn.nFileExtension,"BMP"))
          return 2;
      else if (!strcmp(file+ofn.nFileExtension,"TGA"))
              return 1;
           else if (!strcmp(file+ofn.nFileExtension,"FRQ"))
                   return 4;
     }
  return 0;
}
int GetSaveFileName_(char *file,char *filter,char *defext,char *title)
{
    OPENFILENAME ofn;
    char szFile[256]="",szFileTitle[256]="";

   ofn.lStructSize = sizeof( OPENFILENAME );
   ofn.hwndOwner = hWndFrame;
   ofn.hInstance = hInst;
	ofn.lpstrFilter = filter;
   ofn.lpstrCustomFilter = NULL;
   ofn.nMaxCustFilter = 0;
   ofn.nFilterIndex = 1;
   ofn.lpstrFile = (LPSTR)szFile;
   ofn.nMaxFile = sizeof( szFile );
   ofn.lpstrFileTitle = szFileTitle;
   ofn.nMaxFileTitle = sizeof( szFileTitle );
   ofn.lpstrInitialDir = NULL;
   ofn.lpstrTitle = title;
   ofn.Flags = OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
   ofn.nFileOffset = 0;
   ofn.nFileExtension = 0;
   ofn.lpstrDefExt = defext;
   ofn.lCustData = NULL;
   ofn.lpfnHook = NULL;
   ofn.lpTemplateName = NULL;
   if (GetSaveFileName( &ofn ))
	     {
              strcpy(file,ofn.lpstrFile);
						 return 1;
				 }
	 return 0;
}

int Pic8toDC(class picture8 *pic8,HDC hdc,int x0,int y0,int wx,int wy,int zoom,int destX0,int destY0)
{
	  int x,y,tx,z1,z2,xx,yy,newsx,a,yp;
	  unsigned char *buf,*rgb;
	  struct {
			BITMAPINFOHEADER bmiHeader;
			unsigned char a[1024];
		 } bmi;

	  if (zoom>0)
		  {
			z1=1; z2=zoom;
			newsx=wx*z2;
		  }
	  else {
			  z1=-zoom; z2=1;
			  newsx=wx/z1;
			 }

	  if ((y0+wy>pic8->sy)||(x0+wx>pic8->sx)||x0<0||y0<0||wx<0||wy<0)
		  return 0;

	  x0=x0*z2/z1;
	  y0=y0*z2/z1;
	  wx=wx*z2/z1;
	  wy=wy*z2/z1;
	  tx=wx;

	  if (screen_bitspixel==8)
	  {
	  HDC hMemDC;
	  HBITMAP hbm,hlbm;
	  hMemDC=CreateCompatibleDC(hdc);
	  hbm=CreateCompatibleBitmap(hdc,newsx,16);
	  hlbm=SelectObject(hMemDC,hbm);
     tx+=(tx&1);
	  buf=new unsigned char[16*tx];
	  for( y=0;y<wy;y++ )
		  {
			yy=(y+y0)*z1/z2;
			yp=(y%16)*tx;
			if (pic8->gray)
			for( x=0;x<wx;x++ )
				 {
				  xx=(x+x0)*z1/z2;
				  buf[yp+x]=pal_map[pic8->GetPixelPalIndx(xx,yy)>>1];
				 }
			else
			for( x=0;x<wx;x++ )
				 {
				  xx=(x+x0)*z1/z2;
				  buf[yp+x]=pal_map[pic8->GetPixelPalIndx(xx,yy)];
				 }
			if ((y%16)==15)
				{
				 SetBitmapBits(hbm,(DWORD)tx*16,buf);
				 BitBlt(hdc,destX0,destY0+y-15,wx,16,hMemDC,0,0,SRCCOPY);
				}
			 }
	  if (y%16)
		  {
			SetBitmapBits(hbm,(DWORD)tx*(y%16),buf);
			BitBlt(hdc,destX0,destY0+y-(y%16),wx,y%16,hMemDC,0,0,SRCCOPY);
		  }
	  delete buf;
	  SelectObject(hMemDC,hlbm);
	  DeleteObject(hbm);
	  DeleteDC(hMemDC);
	  }
	  else
	  {
	  bmi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	  bmi.bmiHeader.biCompression=BI_RGB;
	  bmi.bmiHeader.biXPelsPerMeter=6000;
	  bmi.bmiHeader.biYPelsPerMeter=6000;
	  bmi.bmiHeader.biClrUsed=236;
	  bmi.bmiHeader.biClrImportant=236;
	  bmi.bmiHeader.biSizeImage=0;
	  bmi.bmiHeader.biWidth=tx;
	  tx*=3;
	  if (tx%4) tx+=(4-tx%4);
	  buf=new unsigned char[16*tx];
	  bmi.bmiHeader.biHeight=16;
	  bmi.bmiHeader.biPlanes=1;
	  bmi.bmiHeader.biBitCount=24;
	  for( y=0;y<wy;y++ )
		  {
			yp=(15-(y%16))*tx;
			rgb=pic8->buf[(y+y0)*z1/z2];
			for( x=0;x<wx;x++ )
				 {
				  a=rgb[(x+x0)*z1/z2];
				  buf[yp++]=pic8->pal[a].b;
				  buf[yp++]=pic8->pal[a].g;
				  buf[yp++]=pic8->pal[a].r;
				 }
			if ((y%16)==15)
				 SetDIBitsToDevice(hdc, destX0,destY0+y-15, wx,16, 0,0,  0, 16, buf, (struct tagBITMAPINFO *)&bmi, DIB_RGB_COLORS);
			 }
	  if (y%16)
			SetDIBitsToDevice(hdc, destX0,destY0+y-(y%16), wx,(y%16), 0,0,  0,(y%16), buf+(16-(y%16))*tx, (struct tagBITMAPINFO *)&bmi, DIB_RGB_COLORS);
	  delete buf;
	  }

	  return 1;
}

void CalcScroll(HWND hWnd)
{
     RECT rect;
     int z1,z2,sx,sy,wx,wy,repaint=0;
     class windowextra *we;

     we=(class windowextra *)GetWindowLong(hWnd,0);
     if (!we)
        return;

     if (we->zoom>0)
        { z1=1; z2=we->zoom; }
	  else { z1=-we->zoom; z2=1; }

     GetClientRect(hWnd,&rect);

     sx=we->pic8->sx;
     sy=we->pic8->sy;

	  wx=MAX(0,sx-rect.right*z1/z2);
     if (sx*z2/z1>rect.right)
        {
         ShowScrollBar(hWnd,SB_HORZ,1);
         GetClientRect(hWnd,&rect);
         SetScrollRange(hWnd,SB_HORZ,0,wx,0);
         SetScrollPos(hWnd,SB_HORZ,we->x,1);
        }
     else ShowScrollBar(hWnd,SB_HORZ,0);

     wy=MAX(0,sy-rect.bottom*z1/z2);
     if (sy*z2/z1>rect.bottom)
        {
         ShowScrollBar(hWnd,SB_VERT,1);
         GetClientRect(hWnd,&rect);
			SetScrollRange(hWnd,SB_VERT,0,wy,0);
         SetScrollPos(hWnd,SB_VERT,we->y,1);
        }
     else ShowScrollBar(hWnd,SB_VERT,0);
     
     if (we->x>wx)
        {
         repaint=1;
			we->x=wx;
			SetScrollPos(hWnd,SB_HORZ,we->x,1);
        }
     if (we->y>wy)
        {
         repaint=1;
         we->y=wy;
         SetScrollPos(hWnd,SB_VERT,we->y,1);
        }

     if (repaint)
        InvalidateRect(hWnd,0,0);
}

void FitPic8inRect(class picture8 *p8,HDC hdc,RECT *rect)
{
     int z,z1,z2,tx,ty;

     tx=rect->right-rect->left;
	  if (tx>p8->sx)
        z1=tx/p8->sx;
     else z1=-p8->sx/tx-((p8->sx%tx)!=0);
     ty=rect->bottom-rect->top;
     if (ty>p8->sy)
		  z2=ty/p8->sy;
	  else z2=-p8->sy/ty-((p8->sx%tx)!=0);

     if (z1>z2)
        z=z2;
     else z=z1;

     if (z>0)
        { z1=1; z2=z; }
     else { z1=-z; z2=1; }

     tx=tx/2-(p8->sx*z2/z1)/2;
     ty=ty/2-(p8->sy*z2/z1)/2;

     Pic8toDC(p8,hdc,0,0,p8->sx,p8->sy,z,tx,ty);
}

int RealizePalette_(HDC hdc,HPALETTE hPalette,int totcolors)
{
     int a,i;
	  SelectPalette(hdc,hPalette,0);
	  if (i=RealizePalette(hdc));
		  {
         for( a=0;a<totcolors;a++ )
				pal_map[a]=a+10;
		  }
    return i;
}

picture8 *BuildFFTimage(fftdata2D *d)
{
	 int x,y,i,sx,sy;
	 float *f,z,sq,s;
	 picture8 *p;
    byteRGB rgb;
    unsigned char *c1;

	 sq=(float)d->nn1*d->nn2;
    p=new picture8;
    if (!p)
       return 0;

    if (d->isign==-1)
	 if (p->CreatePicture(d->nn1,d->nn2,8,256))
	    ;
	 else {
		 delete p;
		 MessageBox(hWndFrame,"Unable to create image !","FFT 2D",MB_OK|MB_ICONEXCLAMATION);
		 return 0;
		}
    else if (p->CreatePicture(d->sx,d->sy,8,256))
		;
	   else {
			delete p;
			MessageBox(hWndFrame,"Unable to create image !","FFT 2D",MB_OK|MB_ICONEXCLAMATION);
               return 0;
              }

    for( i=0;i<256;i++ )
         {
          rgb.r=i; rgb.g=i; rgb.b=i;
			 p->SetPalette(i,1,&rgb);
         }
    SetWindowText(hWndStatBar,"[Arial,12,100] Building image from FFT data ...");
    if (d->isign==-1)
		 {
		  sx=p->sx;
		  sy=p->sy;
	  s=255.0/log10(1+d->datamax);
	  for( y=0;y<sy;y++,DrawStatusProgress(hWndStatBar,(long)y*100/d->sy) )
		 {
		  f=d->data[y];
		  c1=p->buf[y];
		  for( x=0;x<sx;x++ )
		  {
			z=sqrt((*f)*(*f)+(*(f+1))*(*(f+1)));
			z=s*log10(1+z);
			i=(int)z;
			i=i>255?255:i<0?0:i;
			*c1=i;
			c1++;
			f+=2;
		  }
		 }
	 }
	 else {
		 sx=p->sx;
		 sy=p->sy;
		 for( y=0;y<sy;y++,DrawStatusProgress(hWndStatBar,(long)y*100/d->sy) )
		{
		 f=d->data[y];
		 c1=p->buf[y];
		 for( x=0;x<sx;x++ )
			 {
			  z=*f/sq;
			  i=(int)z;
			  *c1=i>255?255:i<0?0:i;
			  f+=2; c1++;
			 }
		}
		}
	 SetWindowText(hWndStatBar,"");
	 return p;
}

BOOL FAR PASCAL BoxDlgProc(HWND hWnd, WORD Message, WORD wParam, LONG lParam)
{
     static float f=0.0;
     int a1,a2,a3,a4;
	  static int out=0;

     switch( Message )
             {
              case WM_INITDIALOG:
                   {
                     windowextra *we;
			   int z1,z2;
                     we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                     if (we->zoom>0)
                        { z1=1; z2=we->zoom; }
                     else { z1=-we->zoom; z2=1; }
                     SetDlgItemInt(hWnd,601,a1=(we->x+_x0*z1/z2),0);
                     SetDlgItemInt(hWnd,603,a2=(we->y+_y0*z1/z2),0);
                     SetDlgItemInt(hWnd,605,a3=(abs(_x1-_x0)*z1/z2),0);
                     SetDlgItemInt(hWnd,607,a4=(abs(_y1-_y0)*z1/z2),0);
                     sprintf(str,"%.2f",f);
							SetDlgItemText(hWnd,610,str);
                     CheckDlgButton(hWnd,611,out);
                   }
                   break;
              case WM_VSCROLL:
                   {
                    int a,id;
						  HWND hw;
                    windowextra *we;
                    we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                    id=GetWindowWord(HIWORD(lParam),GWW_ID)-1;
                    hw=GetDlgItem(hWnd,id);
                    a=GetDlgItemInt(hWnd,id,0,0);
                    switch( wParam )
                            {
                             case SB_LINEUP:
                                  if (id==601)
                                     a=MIN(we->pic8->sx,a+1);
                                  else if (id==603)
                                          a=MIN(we->pic8->sx,a+1);
                                       else if (id==605||id==607)
                                               a=MIN(10000,a+1);
                                  break;
                             case SB_LINEDOWN:
											 a=MAX(1,a-1);
                                  break;
                            }
                    SetScrollPos(HIWORD(lParam),SB_CTL,a,1);
                    SetDlgItemInt(hWnd,id,a,1);
                    SetFocus(hw);
                    SendMessage(hw,EM_SETSEL,0,MAKELONG(0,-1));
						  {
                     HDC hdc;
                     hdc=GetDC(hWndFocusChild);
                     SetROP2(hdc,R2_NOT);
                     Rectangle(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                     if (_x00!=-1)
                        Rectangle(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                     if (id==601)
                        { _x1=a+(_x1-_x0); _x0=a; }
                     else if (id==603)
                             { _y1=a+(_y1-_y0); _y0=a; }
                          else if (id==605)
                                  _x1=_x0+a;
                               else if (id==607)
                                       _y1=_y0+a;
                     if (_x00!=-1)
                      {
                      _x00=we->pic8->sx-1 - _x0;
                      _y00=we->pic8->sx-1 - _y0;
                      }
                     Rectangle(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                     if (_x00!=-1)
                        Rectangle(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                     ReleaseDC(hWndFocusChild,hdc);
						  }
                   }
                   break;
              case WM_PAINT:
                   {
                    PAINTSTRUCT ps;
                    BeginPaint(hWnd,&ps);
                    FillRect(ps.hdc,&ps.rcPaint,hbackbrush);
                    EndPaint(hWnd,&ps);
                   }
                   break;
              case WM_COMMAND:
                   {
                   windowextra *we;
                   we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                   if (wParam==2)
                      EndDialog(hWnd,0);
                   else if ((wParam==601||wParam==603||wParam==605||wParam==607)&&(HIWORD(lParam)==EN_CHANGE))
                           {
                             HDC hdc;
                             int a;
                             hdc=GetDC(hWndFocusChild);
                             SetROP2(hdc,R2_NOT);
                             Rectangle(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
									  if (_x00!=-1)
                                Rectangle(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                             a=GetDlgItemInt(hWnd,wParam,0,0);
                             if (wParam==601)
                                { _x1=a+(_x1-_x0); _x0=a; }
                             else if (wParam==603)
                                     { _y1=a+(_y1-_y0); _y0=a; }
                                  else if (wParam==605)
                                          _x1=_x0+a;
                                       else if (wParam==607)
                                               _y1=_y0+a;

                             if (_x00!=-1)
                               {
                               _x00=we->pic8->sx-1 - _x0;
                               _y00=we->pic8->sx-1 - _y0;
                              } 
                             Rectangle(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                             if (_x00!=-1)
                                Rectangle(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                             ReleaseDC(hWndFocusChild,hdc);
                           }
                   else if (wParam==1)
                           {
									 windowextra *we;
                            BOOL b;
                            float f1;

                            we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                            a1=GetDlgItemInt(hWnd,601,&b,0);
                            if (!b||a1<1||a1>we->pic8->sx)
                               {
                                MessageBox(hWnd,"Invalid X position for center of rectangle.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            a2=GetDlgItemInt(hWnd,603,&b,0);
                            if (!b||a2<1||a2>we->pic8->sy)
                               {
                                MessageBox(hWnd,"Invalid Y position for center of rectangle.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            a3=GetDlgItemInt(hWnd,605,&b,0);
                            if (!b||a3<1||a3>10000)
                               {
                                MessageBox(hWnd,"Invalid X radius for rectangle.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            a4=GetDlgItemInt(hWnd,607,&b,0);
									 if (!b||a4<1||a4>10000)
                               {
                                MessageBox(hWnd,"Invalid Y radius for rectangle.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            GetDlgItemText(hWnd,610,str,255);
                            if (sscanf(str,"%f",&f1)!=1)
                               {
                                MessageBox(hWnd,"Invalid multiply factor.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            b=IsDlgButtonChecked(hWnd,611);
                            f=f1; out=b;
                            we->fftdata->AplyBoxFilter(a1-a3,a2-a4,a1+a3,a2+a4,f1,b+((_x00!=-1)<<1));
                            delete we->pic8;
                            we->pic8=BuildFFTimage(we->fftdata);
                            InvalidateRect(hWndFocusChild,0,0L);
                            EndDialog(hWnd,1);
                           }
                   }
                   break;
              case WM_CLOSE:
                   EndDialog(hWnd,0);
                   break;
				 }
     return 0;
}

BOOL FAR PASCAL CircleDlgProc(HWND hWnd, WORD Message, WORD wParam, LONG lParam)
{
     static float f=0.0;
     static int out=0;
     static int a1,a2,a3;

     switch( Message )
             {
              case WM_INITDIALOG:
                   {
                     windowextra *we;
                     int z1,z2;
                     we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                     if (we->zoom>0)
                        { z1=1; z2=we->zoom; }
                     else { z1=-we->zoom; z2=1; }
                     SetDlgItemInt(hWnd,601,a1=(we->x+_x0*z1/z2),0);
                     SetDlgItemInt(hWnd,603,a2=(we->y+_y0*z1/z2),0);
                     SetDlgItemInt(hWnd,605,a3=((abs(_x1-_x0)>abs(_y1-_y0)?abs(_x1-_x0):abs(_y1-_y0))*z1/z2),0);
                     sprintf(str,"%.2f",f);
							SetDlgItemText(hWnd,610,str);
                     CheckDlgButton(hWnd,611,out);
                   }
                   break;
              case WM_VSCROLL:
                   {
                    int a,id;
                    HWND hw;
                    windowextra *we;
                    we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                    id=GetWindowWord(HIWORD(lParam),GWW_ID)-1;
                    hw=GetDlgItem(hWnd,id);
                    a=GetDlgItemInt(hWnd,id,0,0);
                    switch( wParam )
                            {
                             case SB_LINEUP:
                                  if (id==601)
                                     a=MIN(we->pic8->sx,a+1);
                                  else if (id==603)
                                          a=MIN(we->pic8->sy,a+1);
                                       else if (id==605)
                                               a=MIN(10000,a+1);
                                  break;
                             case SB_LINEDOWN:
											 a=MAX(1,a-1);
                                  break;
                            }
                    SetScrollPos(HIWORD(lParam),SB_CTL,a,1);
                    SetDlgItemInt(hWnd,id,a,1);
                    SetFocus(hw);
                    SendMessage(hw,EM_SETSEL,0,MAKELONG(0,-1));
                    {
                     HDC hdc;
                     hdc=GetDC(hWndFocusChild);
                     SetROP2(hdc,R2_NOT);
                     Ellipse(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                     if (_x00!=-1)
                        Ellipse(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                     if (id==601)
                        { _x1=a+(_x1-_x0); _x0=a; }
                     else if (id==603)
                             { _y1=a+(_y1-_y0); _y0=a; }
                          else if (id==605)
                                  { _x1=_x0+a; _y1=_y0+a; }
                     if (_x00!=-1)
                      {
                      _x00=we->pic8->sx-1 - _x0;
                      _y00=we->pic8->sx-1 - _y0;
							 }
                     Ellipse(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                     if (_x00!=-1)
                         Ellipse(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                     ReleaseDC(hWndFocusChild,hdc);
                    }
                   }
                   break;
              case WM_PAINT:
                   {
                    PAINTSTRUCT ps;
                    BeginPaint(hWnd,&ps);
                    FillRect(ps.hdc,&ps.rcPaint,hbackbrush);
                    EndPaint(hWnd,&ps);
                   }
                   break;
              case WM_COMMAND:
                   {
                   windowextra *we;
                   we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                   if (wParam==2)
                      EndDialog(hWnd,0);
                   else if ((wParam==601||wParam==603||wParam==605)&&(HIWORD(lParam)==EN_CHANGE))
                           {
									  HDC hdc;
                             int a;
                             hdc=GetDC(hWndFocusChild);
                             SetROP2(hdc,R2_NOT);
                             Ellipse(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                             if (_x00!=-1)
                                Ellipse(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                             a=GetDlgItemInt(hWnd,wParam,0,0);
                             if (wParam==601)
                                { _x1=a+(_x1-_x0); _x0=a; }
                             else if (wParam==603)
                                     { _y1=a+(_y1-_y0); _y0=a; }
                                  else if (wParam==605)
                                          { _x1=_x0+a; _y1=_y0+a; }
                             if (_x00!=-1)
                               {
                               _x00=we->pic8->sx-1 - _x0;
                               _y00=we->pic8->sx-1 - _y0;
                               } 
                             Ellipse(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                             if (_x00!=-1)
                                Ellipse(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                             ReleaseDC(hWndFocusChild,hdc);
                           }
						 else if (wParam==1)
                           {
                            windowextra *we;
                            BOOL b;
                            float f1;

                            we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                            a1=GetDlgItemInt(hWnd,601,&b,0);
                            if (!b||a1<1||a1>we->pic8->sx)
                               {
                                MessageBox(hWnd,"Invalid X position for center of circle.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            a2=GetDlgItemInt(hWnd,603,&b,0);
                            if (!b||a2<1||a2>we->pic8->sy)
                               {
                                MessageBox(hWnd,"Invalid Y position for center of circle.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            a3=GetDlgItemInt(hWnd,605,&b,0);
                            if (!b||a3<1||a3>10000)
                               {
                                MessageBox(hWnd,"Invalid radius for circle.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
										 }
                            GetDlgItemText(hWnd,610,str,255);
                            if (sscanf(str,"%f",&f1)!=1)
                               {
                                MessageBox(hWnd,"Invalid multiply factor.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            b=IsDlgButtonChecked(hWnd,611);
                            f=f1; out=b;
                            we->fftdata->AplyCircularFilter(a1,a2,0,a3,f1,b+((_x00!=-1)<<1));
                            delete we->pic8;
                            we->pic8=BuildFFTimage(we->fftdata);
                            InvalidateRect(hWndFocusChild,0,0L);
									 EndDialog(hWnd,1);
                           }
                   }
                   break;
              case WM_CLOSE:
						 EndDialog(hWnd,0);
						 break;
				 }
	  return 0;
}

void filter_value(fftdata2D *d,double v)
{
	  double min=1e300,max=0,f,t;
	  int x,y;
	  long num=0,tot;
	  tot=(long)d->nn1*d->nn1;

	  for( y=0;y<d->nn1;y++ )
	  for( x=0;x<d->nn1;x++ )
	  {
		f=sqrt(d->data[y][2*x]*d->data[y][2*x]+d->data[y][2*x+1]*d->data[y][2*x+1]);
		if (f>max)
			 max=f;
		if (f<min)
		  min=f;
	  }

	  t=(max-min)*v/100.0;

	  for( y=0;y<d->nn1;y++ )
	  for( x=0;x<d->nn1;x++ )
	  {
		f=sqrt(d->data[y][2*x]*d->data[y][2*x]+d->data[y][2*x+1]*d->data[y][2*x+1]);
		if (f<t)
		{
		d->data[y][2*x]=0;
		d->data[y][2*x+1]=0;
		num++;
		}
	  }
	  sprintf(str,"Removed %.2lf %% of fft coefficients.",num*100.0/tot);
	  MessageBox(NULL,str,"Value Filter",MB_OK);
}

BOOL FAR PASCAL ValueDlgProc(HWND hWnd, WORD Message, WORD wParam, LONG lParam)
{
	  static double value=0.1;
	  switch( Message )
				 {
				  case WM_INITDIALOG:
						 {
							sprintf(str,"%.3lf",value);
							SetDlgItemText(hWnd,601,str);
						 }
						 break;
				  case WM_PAINT:
						 {
						  PAINTSTRUCT ps;
						  BeginPaint(hWnd,&ps);
						  FillRect(ps.hdc,&ps.rcPaint,hbackbrush);
						  EndPaint(hWnd,&ps);
						 }
						 break;
				  case WM_COMMAND:
						 {
						 if (wParam==2)
							 EndDialog(hWnd,0);
						 else if (wParam==1)
									{
									 windowextra *we;
									 BOOL b;
									 double f1;

									 we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
									 GetDlgItemText(hWnd,601,str,255);
									 if (sscanf(str,"%lf",&f1)!=1)
										 {
										  MessageBox(hWnd,"Invalid value.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
										  break;
										 }
									 if (f1<0.0 || f1>100.0)
										 {
										  MessageBox(hWnd,"Invalid value.\nMust be from 0.0 to 100.0 !","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
										  break;
										 }
									 value=f1;
									 SetCursor(hourglass);
									 filter_value(we->fftdata,f1);
									 delete we->pic8;
									 we->pic8=BuildFFTimage(we->fftdata);
									 InvalidateRect(hWndFocusChild,0,0L);
									 EndDialog(hWnd,1);
									}
						 }
						 break;
				  case WM_CLOSE:
						 EndDialog(hWnd,0);
						 break;
				 }
	  return 0;
}

BOOL FAR PASCAL FanDlgProc(HWND hWnd, WORD Message, WORD wParam, LONG lParam)
{
	  static float f=0.0;
	  static int out=0;
	  static float a0,a1;

	  switch( Message )
             {
              case WM_INITDIALOG:
                   {
                     windowextra *we;
                     int z1,z2,dx,dy;
							we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
			   dx=_x0-we->fftdata->nn1/2;
			   dy=_y0-we->fftdata->nn2/2;
			   a0=findangle(dx,dy);
                     a0=Degrees(a0);
							dx=_x1-we->fftdata->nn1/2;
                     dy=_y1-we->fftdata->nn2/2;
                     a1=findangle(dx,dy);
                     a1=Degrees(a1);
                     sprintf(str,"%.2f",a0);
                     SetDlgItemText(hWnd,601,str);
                     sprintf(str,"%.2f",a1);
                     SetDlgItemText(hWnd,603,str);
                     sprintf(str,"%.2f",f);
                     SetDlgItemText(hWnd,610,str);
                     CheckDlgButton(hWnd,611,out);
			 }
						 break;
              case WM_VSCROLL:
                   {
                    int a,id,b;
						  float f;
                    HWND hw;
                    windowextra *we;
						  we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                    id=GetWindowWord(HIWORD(lParam),GWW_ID)-1;
                    hw=GetDlgItem(hWnd,id);
                    GetDlgItemText(hWnd,id,str,255);
                    a=sscanf(str,"%f",&f);
                    if (a==1)
                       a=f;
                    else break;
						  if ((_x0<we->fftdata->nn1/2 && _x1>=we->fftdata->nn1/2) ||
                        (_x0>=we->fftdata->nn1/2 && _x1<we->fftdata->nn1/2))
                       b=-1;
                       else b=1;
                    switch( wParam )
                            {
                             case SB_LINEUP:
                                  if (a==90)
                                     {
                                      a=-89;
                                     }
                                  else a++;
											 break;
                             case SB_LINEDOWN:
                                  if (a==-90)
                                     {
												  a=89;
                                     }
                                  else a--;
                                  break;
                            }
                    {
                     HDC hdc;
                     hdc=GetDC(hWndFocusChild);
                     SetROP2(hdc,R2_NOT);
                     DrawFan(hdc);
                     if (id==601)
								{
                         _x0=we->fftdata->nn1/2+b*1000*cos(Radians(a));
                         _y0=we->fftdata->nn2/2+b*1000*sin(Radians(a));
                        }
                     else if (id==603)
                            {
                             _x1=we->fftdata->nn1/2+b*1000*cos(Radians(a));
                             _y1=we->fftdata->nn2/2+b*1000*sin(Radians(a));
                            }
                     DrawFan(hdc);
                     ReleaseDC(hWndFocusChild,hdc);
                    }
						  SetScrollPos(HIWORD(lParam),SB_CTL,a,1);
						  SetDlgItemInt(hWnd,id,a,1);
                    SetFocus(hw);
                    SendMessage(hw,EM_SETSEL,0,MAKELONG(0,-1));
						 }
                   break;
              case WM_PAINT:
                   {
                    PAINTSTRUCT ps;
                    BeginPaint(hWnd,&ps);
                    FillRect(ps.hdc,&ps.rcPaint,hbackbrush);
                    EndPaint(hWnd,&ps);
                   }
                   break;
              case WM_COMMAND:
						 {
			 if (wParam==2)
                      EndDialog(hWnd,0);
                   else if ((wParam==601||wParam==603)&&(HIWORD(lParam)==EN_CHANGE))
                           {
                           }
                   else if (wParam==1)
                           {
                            windowextra *we;
                            BOOL b;
									 float f1,f2,f3;

									 we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                            GetDlgItemText(hWnd,601,str,255);
                            if (sscanf(str,"%f",&f1)!=1)
                               {
					  MessageBox(hWnd,"Invalid initial angle.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            GetDlgItemText(hWnd,603,str,255);
                            if (sscanf(str,"%f",&f2)!=1)
                               {
                                MessageBox(hWnd,"Invalid final angle.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            GetDlgItemText(hWnd,610,str,255);
                            if (sscanf(str,"%f",&f3)!=1)
										 {
                                MessageBox(hWnd,"Invalid multiply factor.","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
				    b=IsDlgButtonChecked(hWnd,611);
                            if (f1>270) f1-=360;
                            if (f2>270) f1-=360;
                            if (f1> 90) f1-=180;
                            if (f2> 90) f2-=180;
                            a0=Radians(f1); a1=Radians(f2); f=f3; out=b;
                            if (_x0<we->fftdata->nn1/2&&_x1>=we->fftdata->nn1/2 ||
                                _x0>=we->fftdata->nn1/2&&_x1<we->fftdata->nn1/2)
										  b=!b;
									 we->fftdata->AplyFanFilter(a0,a1,f,b);
									 delete we->pic8;
									 we->pic8=BuildFFTimage(we->fftdata);
									 InvalidateRect(hWndFocusChild,0,0L);
                            EndDialog(hWnd,1);
                           }
			 }
                   break;
              case WM_CLOSE:
                   EndDialog(hWnd,0);
                   break;
             }
     return 0;
}

void CheckZoomMenu(int zoom,UINT check)
{
    if (zoom==1)
       CheckMenuItem(hMenu,101,check);
    else if (zoom>1)
            CheckMenuItem(hMenu,100+zoom,check);
         else CheckMenuItem(hMenu,120-zoom,check);
}

LONG FAR PASCAL ImageWndProc( HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam )
{
 static RECT rect;
 static class windowextra *we;
 static int z1,z2;

 switch (Msg)
   {
    case WM_CREATE:
         {
          MDICREATESTRUCT *mcs;
          mcs=(MDICREATESTRUCT *)(((CREATESTRUCT FAR *)lParam)->lpCreateParams);
          SetWindowLong(hWnd,0,mcs->lParam);
         }
         break;
    case WM_CLOSE:
         SendMessage (hWndMDIClient, WM_MDIDESTROY, hWnd, 0L);
         break;
    case WM_DESTROY:
         we=(class windowextra *)GetWindowLong(hWnd,0);
         total_childs--;
         if (!total_childs)
            {
             hWndFocusChild=0;
             EnableMenuItem(hMenu,152,MF_GRAYED);
             EnableMenuItem(hMenu,154,MF_GRAYED);
             CheckZoomMenu(we->zoom,MF_UNCHECKED);
            }
         delete we;
         break;
    case WM_PAINT:
         {
          PAINTSTRUCT ps;
          int x0,y0,wx,wy;
          memset(&ps, 0x00, sizeof(PAINTSTRUCT));
          we=(class windowextra *)GetWindowLong(hWnd,0);
          if (IsIconic(hWnd))
             {
              GetClientRect(hWnd,&rect);
              BeginPaint(hWnd, &ps);
              FitPic8inRect(we->pic8,ps.hdc,&rect);
              EndPaint(hWnd, &ps);
              return 0L;
             }
          GetUpdateRect(hWnd,&rect,0);
          if (we->zoom>0)
             { z1=1; z2=we->zoom; }
          else { z1=-we->zoom; z2=1; }
          if (z2>1)
             {
              rect.left=rect.left/z2*z2;
              rect.top=rect.top/z2*z2;
             }
          BeginPaint(hWnd, &ps);
          x0=(rect.left*z1/z2+we->x);
          y0=(rect.top*z1/z2+we->y);
          wx=(rect.right-rect.left);
          wx=((wx%z2)?1:0) + wx*z1/z2;
          wy=(rect.bottom-rect.top);
          wy=((wy%z2)?1:0) + wy*z1/z2;
          wx=MIN( wx, ((we->pic8)->sx - x0) );
          wy=MIN( wy, ((we->pic8)->sy - y0) );
          Pic8toDC(we->pic8,ps.hdc,x0,y0,wx,wy,we->zoom,rect.left,rect.top);
          if (filter&&hWnd==hWndFocusChild)
            {
             SetROP2(ps.hdc,R2_NOT);
             switch(filter)
               {
                case 2: Ellipse(ps.hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                        if (_x00!=-1)
                           Ellipse(ps.hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                        break;
                case 1: Rectangle(ps.hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                        if (_x00!=-1)
                           Rectangle(ps.hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                        break;
                case 4: DrawFan(ps.hdc);
                        break;
               }
            }
          EndPaint(hWnd, &ps);
			}
         break;
    case WM_SIZE:
         if (wParam==SIZE_RESTORED||wParam==SIZE_MAXIMIZED)
            CalcScroll(hWnd);
         return DefMDIChildProc (hWnd, Msg, wParam, lParam);
    case WM_CHILDACTIVATE:
         PostMessage(hWnd,WM_SETFOCUS,0,0L);
         return DefMDIChildProc (hWnd, Msg, wParam, lParam);
	   break;
    case WM_SETFOCUS:
         {
          class windowextra *we;
          we=(class windowextra *)GetWindowLong(hWnd,0);
          CheckZoomMenu(last_zoom,MF_UNCHECKED);
          hWndFocusChild=hWnd;
          CheckZoomMenu(we->zoom,MF_CHECKED);
          last_zoom=we->zoom;
          SendMessage(hWnd,WM_QUERYNEWPALETTE,0,0L);
         }
         break;
    case WM_HSCROLL:
         {
          int newx,hmax;
			 we=(class windowextra *)GetWindowLong(hWnd,0);
          if (we->zoom>0)
             { z1=1; z2=we->zoom; }
          else { z1=-we->zoom; z2=1; }
          GetScrollRange(hWnd,SB_HORZ,&newx,&hmax);
          newx=we->x;
          switch( wParam )
                  {
                   case SB_LINEUP:
                        newx=MAX(0,newx-4);
                        break;
                   case SB_LINEDOWN:
                        newx=MIN(hmax,newx+4);
                        break;
                   case SB_PAGEUP:
                        newx=MAX(0,newx-16);
                        break;
                   case SB_PAGEDOWN:
                        newx=MIN(hmax,newx+16);
                        break;
                   case SB_THUMBTRACK:
                   case SB_THUMBPOSITION:
                        newx=LOWORD(lParam);
                        newx-=newx&3;
								break;
                  }
          SetScrollPos(hWnd,SB_HORZ,newx,1);
          ScrollWindowEx(hWnd,(we->x-newx)*z2/z1,0,0,0,0,0,SW_INVALIDATE);
          we->x=newx;
         }
         break;
    case WM_VSCROLL:
         {
          int newy,hmax;
          we=(class windowextra *)GetWindowLong(hWnd,0);
          if (we->zoom>0)
             { z1=1; z2=we->zoom; }
          else { z1=-we->zoom; z2=1; }
          GetScrollRange(hWnd,SB_VERT,&newy,&hmax);
          newy=we->y;
          switch( wParam )
                  {
                   case SB_LINEUP:
                        newy=MAX(0,newy-4);
                        break;
                   case SB_LINEDOWN:
                        newy=MIN(hmax,newy+4);
                        break;
						 case SB_PAGEUP:
                        newy=MAX(0,newy-16);
                        break;
                   case SB_PAGEDOWN:
                        newy=MIN(hmax,newy+16);
                        break;
                   case SB_THUMBTRACK:
                   case SB_THUMBPOSITION:
                        newy=LOWORD(lParam);
                        newy-=newy&3;
                        break;
                  }
          SetScrollPos(hWnd,SB_VERT,newy,1);
          ScrollWindowEx(hWnd,0,(we->y-newy)*z2/z1,0,0,0,0,SW_INVALIDATE);
          GetClientRect(hWnd,&rect);
          we->y=newy;
         }
         break;

    case WM_QUERYNEWPALETTE:
         if (screen_bitspixel==8)
         {
          int i;
          HDC hdc;
			 we=(class windowextra *)GetWindowLong(hWnd,0);
          hdc=GetDC(hWnd);
          i=RealizePalette_(hdc,hpal,230);
          ReleaseDC(hWnd,hdc);
          if (i)
             InvalidateRect(hWnd,0,0);
          return i;
         }
         break;

    case WM_LBUTTONDOWN:
         we=(class windowextra *)GetWindowLong(hWnd,0);
         if (hWnd!=hWndFocusChild)
            SendMessage (hWndMDIClient, WM_MDIACTIVATE, hWnd, 0L);
         if (filter&&we->fftdata)
            {
             lmouse=1;
             if (filter==4)
               {
                _x1=_x0=LOWORD(lParam);
                _y1=_y0=HIWORD(lParam);
               }
             else {
                   _x1=_x0=we->pic8->sx/2-1;
						 _y1=_y0=we->pic8->sy/2-1;
                  }
             _x00=_y00=-1;
             SetCapture(hWnd);
            }
         break;
    case WM_RBUTTONDOWN:
         we=(class windowextra *)GetWindowLong(hWnd,0);
         if (hWnd!=hWndFocusChild)
            SendMessage (hWndMDIClient, WM_MDIACTIVATE, hWnd, 0L);
         if (filter&&we->fftdata)
            {
             rmouse=1;
             _x1=_x0=LOWORD(lParam);
             _y1=_y0=HIWORD(lParam);
             _x00=we->pic8->sx-1 - _x0;
             _y00=we->pic8->sx-1 - _y0;
             SetCapture(hWnd);
            }
         break;
	 case WM_MOUSEMOVE:
			we=(class windowextra *)GetWindowLong(hWnd,0);
			if (lmouse==1||rmouse==1)
				{
				 HDC hdc;
				 hdc=GetDC(hWnd);
             SetROP2(hdc,R2_NOT);
             switch(filter)
               {
                case 2: Ellipse(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                        if (_x00!=-1)
                           Ellipse(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                        break;
                case 1: Rectangle(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                        if (_x00!=-1)
                           Rectangle(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                        break;
                case 4: DrawFan(hdc);
                        break;
               }
             _x1=LOWORD(lParam);
             _y1=HIWORD(lParam);
             switch(filter)
               {
                case 2: if (abs(_x1-_x0)>abs(_y1-_y0))
                           _y1=_y0+(_x1-_x0);
                        else _x1=_x0+(_y1-_y0);
                        Ellipse(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                        if (_x00!=-1)
                           Ellipse(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                        break;
                case 1: Rectangle(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                        if (_x00!=-1)
                           Rectangle(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                        break;
                case 4: DrawFan(hdc);
                        break;
               }
             ReleaseDC(hWnd,hdc);
            }
         break;
    case WM_LBUTTONUP:
    case WM_RBUTTONUP:
         if (lmouse==1||rmouse==1)
            {
             int ok;
             lmouse=rmouse=0;
             ReleaseCapture();
             switch (filter)
               {
                case 1: {
                         DLGPROC Dlg;
                         Dlg = (DLGPROC) MakeProcInstance((FARPROC)BoxDlgProc, hInst);
                         ok=DialogBox(hInst, MAKEINTRESOURCE(700), hWndFrame, Dlg);
                         FreeProcInstance((FARPROC) Dlg);
                        }
                        break;
                case 2: {
                         DLGPROC Dlg;
                         Dlg = (DLGPROC) MakeProcInstance((FARPROC)CircleDlgProc, hInst);
                         ok=DialogBox(hInst, MAKEINTRESOURCE(600), hWndFrame, Dlg);
                         FreeProcInstance((FARPROC) Dlg);
                        }
								break;
					 case 4: {
								 DLGPROC Dlg;
								 Dlg = (DLGPROC) MakeProcInstance((FARPROC)FanDlgProc, hInst);
								 ok=DialogBox(hInst, MAKEINTRESOURCE(800), hWndFrame, Dlg);
								 FreeProcInstance((FARPROC) Dlg);
								}
								break;
                }
             if (!ok)
                {
                 HDC hdc;
                 hdc=GetDC(hWnd);
                 SetROP2(hdc,R2_NOT);
                 switch(filter)
                       {
                        case 2: Ellipse(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                                if (_x00!=-1)
                                   Ellipse(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                                break;
                        case 1: Rectangle(hdc,_x0-abs(_x1-_x0),_y0-abs(_y1-_y0),_x0+abs(_x1-_x0),_y0+abs(_y1-_y0));
                                if (_x00!=-1)
                                   Rectangle(hdc,_x00-abs(_x1-_x0),_y00-abs(_y1-_y0),_x00+abs(_x1-_x0),_y00+abs(_y1-_y0));
                                break;
                        case 4: DrawFan(hdc);
                                break;
                       }
                 ReleaseDC(hWnd,hdc);
                }
             filter=0;
             SetWindowText(hWndStatBar,"");
            }
         break;

    default:
            return DefMDIChildProc (hWnd, Msg, wParam, lParam);
   }
 return 0L;
}

char *only_filename(char *s)
{
     char *a;
     if (a=strrchr(s,'\\'))
        return a+1;
     return s;
}

int powerof2(int a)
{
    int b=2;
    while( b<a )
      b*=2;
    return b;
}

fftdata2D *BuildFFTdata(picture8 *p)
{
    int x,y;
    float *f;
    fftdata2D *d;

    d=new fftdata2D;
    if (!d)
       return 0;
    d->sx=p->sx;
    d->sy=p->sy;
    d->nn1=powerof2(p->sx);
    d->nn2=powerof2(p->sy);
    d->isign=1;

    d->data=new float *[d->nn2];
    if (!d->data)
      {
       delete d;
       return 0;
      }

    for( y=0;y<d->nn2;y++ )
	   if (d->data[y]=new float[d->nn1<<1])
            setmem(d->data[y],sizeof(float)*2*d->nn1,0);
         else break;

    if (y<d->nn2)
      {
       for( y--;y>=0;y-- )
            delete d->data[y];
       delete d->data;
       d->data=0;
       delete d;
       return 0;
      }
    SetWindowText(hWndStatBar,"[Arial,12,100] Building FFT data for image ...");
    for( y=0;y<d->nn2;y++,DrawStatusProgress(hWndStatBar,(long)y*100/d->nn2) )
    if (y<p->sy)
     {
      f=d->data[y];
      for( x=0;x<d->nn1;x++ )
      if (x<p->sx)
        {
         *f=(float)p->buf[y][x];
         f+=2;
        }
     }
    SetWindowText(hWndStatBar,"");
    return d;
}

HWND CreateImageWindow(int type,char *file,picture8 *p8)
{
     HWND hWnd;
     class windowextra *we;
     int ok=0,sx,sy,x,y,i;
     picture24 *pic24;
     picture8 *pic8;
     byteRGB rgb;

     we=new class windowextra;

     switch (type)
        {
         case 1:
                  pic24=new class picture24;
                  if (pic24->LoadTGA(file))
                     {
                      we->x=0; we->y=0;
                      we->zoom=1;
                      sx=pic24->sx;
                      sy=pic24->sy;
                      ok=1;
                      we->pic8=new picture8;
                      SetWindowText(hWndStatBar,"[Arial,12,100] Converting image to grayscale ...");
                      we->pic8->CreatePicture(sx,sy,8,256);
                      for( x=0;x<sx;x++,DrawStatusProgress(hWndStatBar,(long)x*100/sx) )
                        for( y=0;y<sy;y++ )
                           {
                            pic24->GetPixel(x,y,rgb);
                            i=rgb.Intensity();
                            we->pic8->SetPixelPalIndx(x,y,i);
                           }
                      for( i=0;i<256;i++ )
                           {
                            rgb.r=i; rgb.g=i; rgb.b=i;
                            we->pic8->SetPalette(i,1,&rgb);
                           }
                     }
                 delete pic24;
                 break;
         case 2:
                pic8=new class picture8;
                if (pic8->LoadBMP(file))
                   {
                    we->x=0; we->y=0;
                    we->zoom=1;
                    sx=pic8->sx;
                    sy=pic8->sy;
                    ok=1;
                    we->pic8=new picture8;
                    SetWindowText(hWndStatBar,"[Arial,12,100] Converting image to grayscale ...");
                    we->pic8->CreatePicture(sx,sy,8,256);
                    for( x=0;x<sx;x++,DrawStatusProgress(hWndStatBar,(long)x*100/sx) )
                     for( y=0;y<sy;y++ )
                        {
                         pic8->GetPixel(x,y,rgb);
                         i=rgb.Intensity();
                         we->pic8->SetPixelPalIndx(x,y,i);
                        }
                    for( i=0;i<256;i++ )
                      {
                       rgb.r=i; rgb.g=i; rgb.b=i;
                       we->pic8->SetPalette(i,1,&rgb);
                      }
                   }
                delete pic8;
                break;
         case 3:
                   we->pic8=p8;
                   we->x=0; we->y=0;
                   we->zoom=1;
                   sx=we->pic8->sx;
                   sy=we->pic8->sy;
                   for( i=0;i<256;i++ )
                      {
                       rgb.r=i; rgb.g=i; rgb.b=i;
                       we->pic8->SetPalette(i,1,&rgb);
                      }
                   ok=1;
                   break;
         case 4:
                   we->fftdata=new fftdata2D;
                   we->fftdata->LoadFFTdata(file);
                   we->fftdata->FindMax();
                   we->pic8=BuildFFTimage(we->fftdata);
                   we->x=0; we->y=0;
                   we->zoom=1;
                   sx=we->pic8->sx;
                   sy=we->pic8->sy;
                   ok=1;
                   *(strrchr(file,'.'))=0;
                   sprintf(str,"FFT of %s",file);
                   file=str;
                   break;
        }

     SetWindowText(hWndStatBar,"");
     sx+=2*GetSystemMetrics(SM_CXFRAME);
     sy+=2*GetSystemMetrics(SM_CYFRAME)+GetSystemMetrics(SM_CYCAPTION)-GetSystemMetrics(SM_CYBORDER);

     if (ok)
        {
         MDICREATESTRUCT mcs;
         mcs.szClass="WFFT2D_CHILD_CLASS";
         if (file==0)
           {
            sprintf(str,"Untitled %i",nuntitled++);
            mcs.szTitle=str;
           }
         else mcs.szTitle=file;
         mcs.hOwner=hInst;
         mcs.x=CW_USEDEFAULT;
         mcs.y=CW_USEDEFAULT;
         mcs.cx=sx;
         mcs.cy=sy;
         mcs.style=0;
         mcs.lParam=(LONG)we;
         hWnd = (HWND)SendMessage( hWndMDIClient,WM_MDICREATE,0,(LONG)&mcs);
         if (hWnd)
            {
             SendMessage(hWnd,WM_QUERYNEWPALETTE,0,0L);
             if (!total_childs)
                {
                 EnableMenuItem(hMenu,152,MF_ENABLED);
                 EnableMenuItem(hMenu,154,MF_ENABLED);
                 CheckZoomMenu(we->zoom,MF_CHECKED);
                 hWndFocusChild=hWnd;
                }
             total_childs++;

             return hWnd;
            }
         else {
               MessageBox(hWndFrame,"Unable to crate child window !","Window Creation Error",MB_OK|MB_ICONSTOP);
              }
        }

     delete we;
     return 0;
}

BOOL FAR PASCAL AboutDlgProc(HWND hWnd, WORD Message, WORD wParam, LONG lParam)
{
     switch( Message )
             {
              case WM_INITDIALOG:
                   SetDlgItemText(hWnd,50,"[Times,24,200]2D Fast Fourier Transform");
                   break;
              case WM_PAINT:
                   {
                    PAINTSTRUCT ps;
                    BeginPaint(hWnd,&ps);
                    FillRect(ps.hdc,&ps.rcPaint,hbackbrush);
                    EndPaint(hWnd,&ps);
                   }
                   break;
              case WM_COMMAND:
                   if (wParam==1)
                      EndDialog(hWnd,1);
                   break;
              case WM_CLOSE:
                   EndDialog(hWnd,0);
                   break;
             }
     return 0;
}


BOOL FAR PASCAL BuildImageDlgProc(HWND hWnd, WORD Message, WORD wParam, LONG lParam)
{
   static char eq[512]="(cos(ux)*cos(uy)+1)*120",sux0[64]="0",sux1[64]="4*pi",suy0[64]="0",suy1[64]="4*pi";
   static int sx=128,sy=128;
   static double ux0,ux1,uy0,uy1;

     switch( Message )
             {
              case WM_INITDIALOG:
                   SetDlgItemInt(hWnd,502,sx,0);
                   SetDlgItemInt(hWnd,503,sy,0);
                   SetDlgItemText(hWnd,501,eq);
                   SetDlgItemText(hWnd,504,sux0);
                   SetDlgItemText(hWnd,505,sux1);
                   SetDlgItemText(hWnd,506,suy0);
                   SetDlgItemText(hWnd,507,suy1);
                   break;
              case WM_PAINT:
                   {
                    PAINTSTRUCT ps;
                    BeginPaint(hWnd,&ps);
                    FillRect(ps.hdc,&ps.rcPaint,hbackbrush);
                    EndPaint(hWnd,&ps);
                   }
                   break;
              case WM_COMMAND:
                   if (wParam==2)
                      EndDialog(hWnd,0);
                   else if (wParam==1)
                           {
                            BOOL bfp;
                            HWND hw;
                            double z,dx,dy;
                            int x,y;
                            picture8 *p8;
                            unsigned char *c1;
                            windowextra *we;

                            sx=GetDlgItemInt(hWnd,502,&bfp,0);
                            if (!bfp||sx<8||sx>10240)
                               {
                                MessageBox(hWnd,"Invalid image dimension !","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            sy=GetDlgItemInt(hWnd,503,&bfp,0);
                            if (!bfp||sy<8||sy>10240)
                               {
                                MessageBox(hWnd,"Invalid image dimension !","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            GetDlgItemText(hWnd,501,eq,512);
                            if (eq[0]==0)
                               {
                                MessageBox(hWnd,"Equation must be a valid function !","Invalid Parameter",MB_OK|MB_ICONEXCLAMATION);
                                break;
                               }
                            GetDlgItemText(hWnd,504,sux0,256);
                            get_exp(sux0,&ux0);
                            GetDlgItemText(hWnd,505,sux1,256);
                            get_exp(sux1,&ux1);
                            GetDlgItemText(hWnd,506,suy0,256);
                            get_exp(suy0,&uy0);
                            GetDlgItemText(hWnd,507,suy1,256);
                            get_exp(suy1,&uy1);
                            p8=new picture8;
                            if (!p8->CreatePicture(sx,sy,8,256))
                               {
                                MessageBox(hWnd,"Unable to create image !","Memory Error",MB_OK|MB_ICONEXCLAMATION);
                                delete p8;
                                break;
                               }
                            _SX_=sx; _SY_=sy;
									 SetCursor(hourglass);
                            dx=(ux1-ux0)/_SX_;
                            dy=(uy1-uy0)/_SY_;
                            SetWindowText(hWndStatBar,"[Arial,12,100] Building image ...");
                            _UX_=ux0;
                            _UY_=uy0;
                            for( y=0;y<sy;y++,DrawStatusProgress(hWndStatBar,(long)y*100/sy) )
                            {
                             c1=p8->buf[y];
                             _Y_=y;
                             _UX_=ux0;
                             for( x=0;x<sx;x++ )
                                 {
                                  _X_=x;
                                  get_exp(eq,&z);
                                  *c1=( (z<0.0)?0:( (z>255.0)?255:(unsigned char)z ) );
                                  c1++;
                                  _UX_+=dx;
                                 }
                             _UY_+=dy;
                            }
                            CreateImageWindow(3,0,p8);
                            EndDialog(hWnd,1);
									}
                   break;
              case WM_CLOSE:
                   EndDialog(hWnd,0);
                   break;
             }
     return 0;
}

fftdata2D *CopyFFTdata(fftdata2D *s)
{
    int y;
    fftdata2D *d;

    d=new fftdata2D;
    if (!d)
       return 0;
    d->sx=s->sx;
    d->sy=s->sy;
    d->nn1=s->nn1;
    d->nn2=s->nn2;
    d->isign=s->isign;
    d->datamax=s->datamax;

    d->data=new float *[d->nn2];
    if (!d->data)
      {
       delete d;
       return 0;
      }
	 for( y=0;y<d->nn2;y++ )
	   if (d->data[y]=new float[d->nn1<<1])
            memcpy(d->data[y],s->data[y],sizeof(float)*2*d->nn1);
         else break;

    if (y<d->nn2)
      {
       for( y--;y>=0;y-- )
            delete d->data[y];
       delete d->data;
       d->data=0;
       delete d;
       return 0;
      }

	 return d;
}

void somacirculos(class windowextra *we)
{
		int x,y,sx,sy;
		double total,r1,r2,r3,r4,r5;
 /*
		FILE *f;
		f=fopen("raios.txt","wt");
		for(x=0;x<we->fftdata->nn1;x++)
		 {
		 r1=we->fftdata->SomaRaio(-x);
		 fprintf(f,"%lf\n",r1);
		 }
		fclose(f);

	*/
		sx=we->fftdata->nn1*2;
		sy=we->fftdata->nn2/2;
		SetCursor(hourglass);
		total=we->fftdata->SomaRaio(sx,we->pic8);
		r1=we->fftdata->SomaRaio(sy*5/100,we->pic8)/total*100.0;
		r2=we->fftdata->SomaRaio(sy*15/100,we->pic8)/total*100.0;
		r3=we->fftdata->SomaRaio(sy*25/100,we->pic8)/total*100.0;
		r4=we->fftdata->SomaRaio(sy*40/100,we->pic8)/total*100.0;
		r5=we->fftdata->SomaRaio(sy*70/100,we->pic8)/total*100.0;
		sprintf(str,"%%Radii \t= %%Power\n\n5 \t= %0.2lf%%\n15 \t= %0.2lf%%\n25 \t= %0.2lf%%\n40 \t= %0.2lf%%\n70 \t= %0.2lf%%",r1,r2,r3,r4,r5);
		InvalidateRect(hWndFocusChild,0,0);
		UpdateWindow(hWndFocusChild);
		MessageBox(NULL,str,"Image Power",MB_OK);
}

LONG FAR PASCAL FrameWndProc(HWND hWnd, WORD Msg, WORD wParam, LONG lParam)
{
 switch (Msg)
	{
	 case WM_COMMAND:
			{
			 class windowextra *we;
			 if (wParam>101&&wParam<117&&hWndFocusChild)
             {
              we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
              if (we->zoom==wParam-100)
                 return 0L;
              CheckZoomMenu(we->zoom,MF_UNCHECKED);
              CheckMenuItem(hMenu,100+we->zoom,MF_UNCHECKED);
              last_zoom=we->zoom=wParam-100;
              CheckMenuItem(hMenu,100+we->zoom,MF_CHECKED);
              CalcScroll(hWndFocusChild);
              InvalidateRect(hWndFocusChild,0,0);
				 }
           else if (wParam>121&&wParam<137&&hWndFocusChild)
                   {
                    we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
						  if (we->zoom==-(wParam-120))
                       return 0L;
                    CheckZoomMenu(we->zoom,MF_UNCHECKED);
                    last_zoom=we->zoom=-(wParam-120);
                    CheckZoomMenu(we->zoom,MF_CHECKED);
                    CalcScroll(hWndFocusChild);
                    InvalidateRect(hWndFocusChild,0,1);
						 }
			  else
           switch (wParam)
           {
            case 101: if (!hWndFocusChild)
                         return 0;
                      we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
                      if (we->zoom==1)
                         return 0L;
                      CheckZoomMenu(we->zoom,MF_UNCHECKED);
                      last_zoom=we->zoom=1;
                      CheckZoomMenu(we->zoom,MF_CHECKED);
                      CalcScroll(hWndFocusChild);
                      InvalidateRect(hWndFocusChild,0,1);
                      break;
            case 151: {
                       char file[256];
							  int type=1;

			     if (type=GetOpenFileName_(file,"All (*.BMP,*.TGA,*.FRQ)\0*.BMP;*.TGA;*.FRQ\0Windows Bitmap (*.BMP)\0*.BMP\0Targa 24 bits (*.TGA)\0*.TGA\0Frequency Data (*.FRQ)\0*.FRQ\0","","Select Image to Open"))
								  {
									SetCursor(hourglass);
									if (CreateImageWindow(type,only_filename(file),0))
										 return 0L;
								  }
							 }
							 break;
				case 152: if (hWndFocusChild)
								 {
								  char file[256];
								  we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
								  if (we->fftdata==0)
										if (GetSaveFileName_(file,"Windows Bitmap (*.BMP)\0*.BMP\0","BMP","Save Image"))
											{
											 we->pic8->SaveBMP(file);
											 SetWindowText(hWnd,only_filename(file));
											}
										else ;
								  else
								  if (we->fftdata->isign==1)
									  {
										if (GetSaveFileName_(file,"Windows Bitmap (*.BMP)\0*.BMP\0","BMP","Save Image"))
											{
											 we->pic8->SaveBMP(file);
											 SetWindowText(hWnd,only_filename(file));
											}
									  }
								  else {
										  if (GetSaveFileName_(file,"Frequency Data (*.FRQ)\0*.FRQ\0","FRQ","Save Frequency Space Image"))
												 we->fftdata->SaveFFTdata(file);
										 }
								 }
							 break;
				case 156: {
							  DLGPROC Dlg;
							  Dlg = (DLGPROC) MakeProcInstance((FARPROC)AboutDlgProc, hInst);
                       DialogBox(hInst, MAKEINTRESOURCE(300), hWndFrame, Dlg);
                       FreeProcInstance((FARPROC) Dlg);
                      }
                      break;
            case 161: {
                       DLGPROC Dlg;
                       Dlg = (DLGPROC) MakeProcInstance((FARPROC)BuildImageDlgProc, hInst);
                       DialogBox(hInst, MAKEINTRESOURCE(500), hWndFrame, Dlg);
                       FreeProcInstance((FARPROC) Dlg);
							 }
							 break;
				case 165:
							  SetCursor(hourglass);
							  we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
							  if (we->fftdata)
								  somacirculos(we);
								else MessageBox(hWndFrame,"Image power is only for Fourier domain images !","Error",MB_OK|MB_ICONEXCLAMATION);
							 break;
				case 162: if (hWndFocusChild)
							 {
							  SetCursor(hourglass);
							  we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
							  if (we->fftdata)
								  {
									SendMessage(hWnd,WM_COMMAND,101,0L);
									filter=1;
									SetWindowText(hWndStatBar,"[Arial,12,100] Left mouse to centred rectangle, right mouse to set center. Drag mouse for scale rectangle.");
								  }
							  else MessageBox(hWndFrame,"Filters can only be used with images in the Fourier domain !","Filter Error",MB_OK|MB_ICONEXCLAMATION);
							 }
							 break;
				case 163: if (hWndFocusChild)
							 {
							  SetCursor(hourglass);
							  we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
							  if (we->fftdata)
								  {
									SendMessage(hWnd,WM_COMMAND,101,0L);
									filter=2;
									SetWindowText(hWndStatBar,"[Arial,12,100] Left mouse for centred circle, right mouse to set center. Drag mouse to set circle radius.");
								  }
							  else MessageBox(hWndFrame,"Filters can only be used with images in the Fourier domain !","Filter Error",MB_OK|MB_ICONEXCLAMATION);
							 }
							 break;
				case 164: if (hWndFocusChild)
							 {
							  SetCursor(hourglass);
							  we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
							  if (we->fftdata)
								  {
									SendMessage(hWnd,WM_COMMAND,101,0L);
									filter=4;
									SetWindowText(hWndStatBar,"[Arial,12,100] Left mouse for initial fan angle. Drag mouse for set final fan angle.");
								  }
							  else MessageBox(hWndFrame,"Filters can only be used with images in the Fourier domain !","Filter Error",MB_OK|MB_ICONEXCLAMATION);
							 }
							 break;
				case 171: SendMessage (hWndMDIClient, WM_MDICASCADE, 0, 0L);
						 break;
				case 173: SendMessage (hWndMDIClient, WM_MDITILE, 0, 0L);
							 break;
				case 174: SendMessage (hWndMDIClient, WM_MDIICONARRANGE, 0, 0L);
							 break;
				case 154: SendMessage (hWndMDIClient, WM_MDIDESTROY, hWndFocusChild, 0L);
							 break;
				case 155: PostMessage (hWnd, WM_CLOSE, 0, 0L);
							 break;
				case 166:  we=(class windowextra *)GetWindowLong(hWndFocusChild,0);
							  if (we->fftdata)
								{
								 DLGPROC Dlg;
								 Dlg = (DLGPROC) MakeProcInstance((FARPROC)ValueDlgProc, hInst);
								 DialogBox(hInst, MAKEINTRESOURCE(900), hWndFrame, Dlg);
								 FreeProcInstance((FARPROC) Dlg);
								}
							   else MessageBox(hWndFrame,"Filters can only be used with images in the Fourier domain !","Filter Error",MB_OK|MB_ICONEXCLAMATION);
								break;

				case 160: {
							  windowextra *we;
							  fftdata2D *data;
							  picture8 *p8;
                       HWND hw;

                       if (!hWndFocusChild)
                           break;
                       SetCursor(hourglass);
                       we=(windowextra *)GetWindowLong(hWndFocusChild,0);
                       if (we->fftdata)
                          data=CopyFFTdata(we->fftdata);
                       else data=BuildFFTdata(we->pic8);
                       if (!data)
                          {
                           MessageBox(hWndFrame,"Unable to create fftdata !","Memory Error",MB_OK|MB_ICONEXCLAMATION);
                           break;
                          }
                       data->four2();
                       data->FindMax();
                       p8=BuildFFTimage(data);
                       if (!p8)
                          {
                           delete data;
                           break;
                          }
                       GetWindowText(hWndFocusChild,buf,256);
							  if (data->isign==1)
                          {
                           char *s;
									if ((s=strrchr(buf,' '))-buf>6)
                              {
                               *s=0;
                               sprintf(str,"%s %i",&buf[7],atoi(++s)+1);
                              }
                           else sprintf(str,"%s 1",&buf[7]);
                           hw=CreateImageWindow(3,str,p8);
                           delete data;
                          }
                       else {
                             sprintf(str,"FFT of %s",buf);
                             hw=CreateImageWindow(3,str,p8);
                             we=(windowextra *)GetWindowLong(hw,0);
                             we->fftdata=data;
                            }
                      }
                      break;
            default: return DefFrameProc (hWnd,hWndMDIClient,Msg,wParam,lParam);
           }
          }
         break;

    case WM_SIZE:
         UpdateStatusBarPos(hWnd,hWndMDIClient);
         break;

    case WM_CLOSE:
			DestroyWindow(hWnd);
         break;

    case WM_DESTROY:
         if (hpal)
            DeleteObject(hpal);
         PostQuitMessage(0);
         break;
    case WM_CREATE:
         {
          CLIENTCREATESTRUCT ccs;
          HDC hdc;
          hMenu=GetMenu(hWnd);
          ccs.hWindowMenu  = GetSubMenu(hMenu,3);
          ccs.idFirstChild = 500;
          hWndMDIClient    = CreateWindow( "mdiclient",NULL,WS_CHILD|WS_CLIPCHILDREN|WS_HSCROLL|WS_VSCROLL,
	                                         0,0,50,100,hWnd,0xFAF,hInst,(LPSTR)&ccs );
          ShowWindow(hWndMDIClient,SW_SHOW);
			 hdc=GetDC(hWnd);
          screen_bitspixel=GetDeviceCaps(hdc,BITSPIXEL)*
                           GetDeviceCaps(hdc,PLANES);
          if (screen_bitspixel==8)
             {
              int a=0;
              lgpl.palVersion=0x0300;
              lgpl.palNumEntries=1;
              hpal=CreatePalette((LOGPALETTE FAR *)&lgpl);
				  ResizePalette(hpal,236);
              for( a=0;a<128;a++ )
                 {
                  pe[a].peRed=(a<<1);
                  pe[a].peGreen=(a<<1);
                  pe[a].peBlue=(a<<1);
                  pe[a].peFlags=PC_NOCOLLAPSE;
                 }
              for( a=128;a<236;a++ )
                   {
                    pe[a].peRed=0;
                    pe[a].peGreen=0;
                    pe[a].peBlue=0;
                    pe[a++].peFlags=PC_NOCOLLAPSE;
                   }
				  SetPaletteEntries(hpal,0,236,(PALETTEENTRY FAR *)&pe);
             }
          ReleaseDC(hWnd,hdc);
          hWndStatBar=CreateStatusBar(hInst,hWnd,0,100,24,SB_ALIGN_LEFT);
         }
      break;
    default: return DefFrameProc (hWnd,hWndMDIClient,Msg,wParam,lParam);
    }
 return 0L;
}

int RegisterClasses(void)
{
 WNDCLASS wc;
 HBITMAP  hbitback;
 LOGBRUSH lb;

 hbitback   = LoadBitmap(hInst,"BackGround");
 lb.lbStyle = BS_PATTERN;
 lb.lbColor = RGB(128,128,128);
 lb.lbHatch = hbitback;
 hbackbrush = CreateBrushIndirect(&lb);
 DeleteObject(hbitback);
 hbitback   = LoadBitmap(hInst,"ImageBackGround");
 lb.lbStyle = BS_PATTERN;
 lb.lbColor = RGB(128,128,128);
 lb.lbHatch = hbitback;
 himagebackbrush = CreateBrushIndirect(&lb);
 DeleteObject(hbitback);
 hourglass=LoadCursor(NULL,IDC_WAIT);

 memset(&wc, 0x00, sizeof(WNDCLASS));

 wc.style	  = 0;
 wc.lpfnWndProc   = (WNDPROC)FrameWndProc;
 wc.cbClsExtra    = 0;
 wc.cbWndExtra    = 0;
 wc.hInstance     = hInst;
 wc.hIcon	  = LoadIcon(hInst,"WFFT2D_ICON");
 wc.hCursor	  = LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground = COLOR_APPWORKSPACE+1;
 wc.lpszMenuName  = "WFFT2D_MENU";
 wc.lpszClassName = "WFFT2D_FRAME_CLASS";

 if(!RegisterClass(&wc))
   return 0;

 wc.lpfnWndProc   = (WNDPROC)ImageWndProc;
 wc.hIcon         = NULL;
 wc.hCursor       = LoadCursor(hInst,"WFFT2D_CURSOR");
 wc.lpszMenuName  = NULL;
 wc.cbWndExtra    = 4;
 wc.lpszClassName = "WFFT2D_CHILD_CLASS";
 wc.hbrBackground = himagebackbrush;

 if(!RegisterClass(&wc))
   {
    UnregisterClass("WFFT2D_FRAME_CLASS",hInst);
    return 0;
   }

 if (!RegisterStatusBarClass(hInst))
    {
     UnregisterClass("WFFT2D_FRAME_CLASS",hInst);
     UnregisterClass("WFFT2D_CHILD_CLASS",hInst);
     return 0;
	 }

 hAccel=LoadAccelerators(hInst,"WFFT2D_ACCEL");

 return 1;
}

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
 MSG   msg;
 HINSTANCE  hLib;

 if(!hPrevInstance)
   {
    hInst = hInstance;
    if (!RegisterClasses())
       {
        MessageBox(NULL, "Unable to register classes !",
                   NULL, MB_ICONSTOP|MB_OK);
        return 0;
       }
   }

 hLib=LoadLibrary("fpobtn.dll");
 if (!hLib)
    MessageBox(NULL,"Unable to open 'FPOBTN.DLL' !\nThis file must be in the SYSTEM directory.","Library Error",MB_OK|MB_ICONSTOP);
 else {
		 hWndFrame = CreateWindow ("WFFT2D_FRAME_CLASS","The Computer Image - 2D Fast Fourier Transform",
                                 WS_OVERLAPPEDWINDOW|WS_CLIPCHILDREN,
                                 CW_USEDEFAULT,0,CW_USEDEFAULT,0,
						NULL,NULL,hInst,NULL);
       ShowWindow(hWndFrame,nCmdShow);
       if (hWndFrame)
           {
            while( GetMessage(&msg,0,0,0) )
              if (!TranslateMDISysAccel(hWndMDIClient,&msg)&&!TranslateAccelerator(hWndFrame,hAccel,&msg))
                 {
                  TranslateMessage(&msg);
                  DispatchMessage(&msg);
                 }
           }
       else MessageBox(NULL,"Unable to create main window !","Window Creation Error",MB_OK|MB_ICONSTOP);
      }
 
 UnregisterClass("WFFT2D_CLASS", hInst);
 UnregisterClass("WFFT2D_CHILD_CLASS", hInst);
 UnregisterClass("FPO_STATUSBAR", hInst);
 DeleteObject(hbackbrush);
 DeleteObject(himagebackbrush);
 DeleteObject(hourglass);

 FreeLibrary(hLib);

 return 0;
}
